#
# makeGUI -- creates all main GUI widgets
# and loads images for the button bar
#
proc makeGUI { } {
global sld cv
frame .mb
frame .bar
frame .c
## width and height are the sizes of the _widget_, not the image edited
canvas .c.c -bg $sld(background) -width $sld(width) -height $sld(height) \
	-scrollregion [list -1c -1c $sld(dwidth) $sld(dheight)] \
	-confine 1 -closeenough 15.0 \
	-xscrollcommand {.c.cscrollh set} -yscrollcommand {.c.cscrollv set}

scrollbar .c.cscrollh -orient horizontal -width 10 -command {.c.c xview}
scrollbar .c.cscrollv -orient vertical -width 10 -command {.c.c yview}
label .cnt -relief groove -width 12
label .st -relief sunken

set cv .c.c
#### DavidL

menubutton .mb.file -text File -underline 0 -menu .mb.file.m
menubutton .mb.edit -text Edit -underline 0 -menu .mb.edit.m
menubutton .mb.layout -text Layout -underline 0 -menu .mb.layout.m
menubutton .mb.objects -text Objects -underline 0 -menu .mb.objects.m
#menubutton .mb.effects -text Effects -underline 5 -menu .mb.effects.m \
		-state disabled
menubutton .mb.help -text Help -underline 0 -menu .mb.help.m

menu .mb.file.m
.mb.file.m add command -label "Load..." -accelerator Clt+L -underline 0 \
	-command fileLoad
.mb.file.m add command -label "New" -accelerator Ctl+N -underline 0 \
	-command fileNew
.mb.file.m add command -label "Merge..." -underline 0 \
	-command fileMerge
.mb.file.m add command -label "Save as..." -accelerator Ctl+S -underline 0 \
	-command fileSave
.mb.file.m add checkbutton -label "Contact sheet" -underline 0\
	-variable sld(multi) -command showMulti
.mb.file.m add command -label "Export..." -underline 0 \
	-command fileExport
.mb.file.m add command -label Print -underline 0 \
	-command getPrintOptions
.mb.file.m add separator
.mb.file.m add command -label "Quit" -accelerator Ctl+Q -underline 0 \
	-command "saveConfig; exit"
.mb.file.m add separator

menu .mb.edit.m
#.mb.edit.m add command -label Undo -underline 0 -state disabled
#.mb.edit.m add command -label Redo -underline 0 -state disabled
#.mb.edit.m add separator
.mb.edit.m add command -label "Copy" -accelerator "     Ctl+C" -underline 0 \
	-command copyObject
.mb.edit.m add command -label "Paste" -accelerator "     Ctl+V" -underline 0 \
	-command pasteObject
.mb.edit.m add command -label "Cut" -accelerator "     Ctl+X" -underline 2 \
	-command cutObject
.mb.edit.m add separator
.mb.edit.m add command -label "Bring to front" -accelerator "     Ctl+F" -underline 9 \
	-command frontObject
.mb.edit.m add command -label "Send to back" -accelerator "     Ctl+B" -underline 9 \
	-command backObject
.mb.edit.m add command -label "Group objects" -accelerator "     Ctl+G" -underline 0 \
	-command groupObjects
.mb.edit.m add command -label "Ungroup objects" -accelerator "Shft+Ctl+G" \
	-command ungroupObjects
.mb.edit.m add separator
.mb.edit.m add command -label "Next slide" -accelerator "PgDown" \
	-command nextSlide
.mb.edit.m add command -label "Previous slide" -accelerator "PgUp" \
	-command prevSlide

menu .mb.objects.m
.mb.objects.m add command -label Line -underline 0 \
	-command {doBindings line}
.mb.objects.m add command -label Frame -underline 0 \
	-command {doBindings frame}
.mb.objects.m add command -label Box -underline 0 \
	-command {doBindings box}
.mb.objects.m add command -label Ellipse -underline 0 \
	-command {doBindings ellipse}
.mb.objects.m add command -label "Filled ellipse" -underline 0 \
	-command {doBindings fellipse}
.mb.objects.m add command -label Text -underline 0 \
	-command {doBindings text}
.mb.objects.m add command -label "Boxed text" -underline 2 \
	-command {doBindings btext}
.mb.objects.m add command -label "Image" -underline 0 \
	-command {doBindings image}
.mb.objects.m add separator
.mb.objects.m add command -label "Slideshow" \
	-command {doBindings slideshow}

menu .mb.layout.m
.mb.layout.m add command -label "Font browse..." -command setFontDialog
.mb.layout.m add cascade -label "Font family" -menu .mb.layout.m.ff
.mb.layout.m add cascade -label "Font size" -menu .mb.layout.m.fs
.mb.layout.m add separator
.mb.layout.m add command -label "Color palette..." -underline 0 \
	-command showPalette  
.mb.layout.m add cascade -label "Line width" -menu .mb.layout.m.w
.mb.layout.m add cascade -label "Line style" -menu .mb.layout.m.sty
.mb.layout.m add cascade -label "Text alignment" -menu .mb.layout.m.t
.mb.layout.m add cascade -label "Grid resolution" -menu .mb.layout.m.s
.mb.layout.m add command -label "Background pattern..." -command getBackground
.mb.layout.m add checkbutton -label "show Rulers" -variable sld(rulersenable) \
	-command {makeRulers}
.mb.layout.m add cascade -label "Zoom..." -underline 0 -menu .mb.layout.m.z

menu .mb.layout.m.ff
set index 0
foreach family $sld(fontfamilies) {
	.mb.layout.m.ff add radiobutton -label $family -underline 0 \
		-variable sld(fontfamily) -value $family
	incr index
}

menu .mb.layout.m.fs
.mb.layout.m.fs add radiobutton -label 12 -underline 1 \
	-variable sld(fontsize) -value 12
.mb.layout.m.fs add radiobutton -label 14 -underline 1 \
	-variable sld(fontsize) -value 14
.mb.layout.m.fs add radiobutton -label 18 -underline 1 \
	-variable sld(fontsize) -value 18
.mb.layout.m.fs add radiobutton -label 24 \
	-variable sld(fontsize) -value 24
.mb.layout.m.fs add radiobutton -label 36 \
	-variable sld(fontsize) -value 36
.mb.layout.m.fs add radiobutton -label 48 \
	-variable sld(fontsize) -value 48
.mb.layout.m.fs add radiobutton -label 72 \
	-variable sld(fontsize) -value 72
#### set default fontsize and fontfamily (first)
.mb.layout.m.ff invoke 1
.mb.layout.m.fs invoke 5

menu .mb.layout.m.w
.mb.layout.m.w add radiobutton -label "Width 1" \
	-variable sld(lwidth) -value 1
.mb.layout.m.w add radiobutton -label "Width 2" \
	-variable sld(lwidth) -value 2
.mb.layout.m.w add radiobutton -label "Width 3" \
	-variable sld(lwidth) -value 3
.mb.layout.m.w add radiobutton -label "Width 4" \
	-variable sld(lwidth) -value 4
.mb.layout.m.w add radiobutton -label "Width 6" \
	-variable sld(lwidth) -value 6
.mb.layout.m.w add radiobutton -label "Width 8" \
	-variable sld(lwidth) -value 8
.mb.layout.m.w add radiobutton -label "Width 12" \
	-variable sld(lwidth) -value 12

menu .mb.layout.m.sty
.mb.layout.m.sty add radiobutton -label "_____" \
	-variable sld(lstyle) -value " "
.mb.layout.m.sty add radiobutton -label "....." \
	-variable sld(lstyle) -value "."
.mb.layout.m.sty add radiobutton -label ".-.-." \
	-variable sld(lstyle) -value ".-"
.mb.layout.m.sty add radiobutton -label ".. .. .." \
	-variable sld(lstyle) -value "..  "
.mb.layout.m.sty add radiobutton -label "..-..-" \
	-variable sld(lstyle) -value "..-"
 

menu .mb.layout.m.t
.mb.layout.m.t add radiobutton -label "Center text" \
	-variable sld(txtalign) -value center
.mb.layout.m.t add radiobutton -label "Right align"\
	-variable sld(txtalign) -value right
.mb.layout.m.t add radiobutton -label "Left align" \
	-variable sld(txtalign) -value left

menu .mb.layout.m.s
.mb.layout.m.s add radiobutton -label "Size 1" \
	-variable sld(snap) -value 1
.mb.layout.m.s add radiobutton -label "Size 2" \
	-variable sld(snap) -value 2
.mb.layout.m.s add radiobutton -label "Size 4" \
	-variable sld(snap) -value 4
.mb.layout.m.s add radiobutton -label "Size 8" \
	-variable sld(snap) -value 8
.mb.layout.m.s add radiobutton -label "Size 16" \
	-variable sld(snap) -value 16
.mb.layout.m.s add radiobutton -label "Size 32" \
	-variable sld(snap) -value 32	

menu .mb.layout.m.z
.mb.layout.m.z add radiobutton -label "1:5" \
	-variable sld(zoom) -value 0.2 -command applyZoom
.mb.layout.m.z add radiobutton -label "1:3" \
	-variable sld(zoom) -value 0.333 -command applyZoom
.mb.layout.m.z add radiobutton -label "1:2.5" \
	-variable sld(zoom) -value 0.4 -command applyZoom
.mb.layout.m.z add radiobutton -label "1:2" \
	-variable sld(zoom) -value 0.5 -command applyZoom
.mb.layout.m.z add radiobutton -label "1:1" \
	-variable sld(zoom) -value 1.0 -command applyZoom
.mb.layout.m.z add radiobutton -label "2:1" \
	-variable sld(zoom) -value 2.0 -command applyZoom
.mb.layout.m.z add radiobutton -label "3:1" \
	-variable sld(zoom) -value 3.0 -command applyZoom
.mb.layout.m.z add radiobutton -label "5:1" \
	-variable sld(zoom) -value 5.0 -command applyZoom
.mb.layout.m.z add radiobutton -label "7:1" \
	-variable sld(zoom) -value 7.0 -command applyZoom

#.mb.layout.m add separator
#.mb.layout.m add command -label footer -underline 0 -state disabled
#.mb.layout.m add command -label background -underline 0 -state disabled
 
.mb.layout.m.w invoke 4
.mb.layout.m.t invoke 1
.mb.layout.m.s invoke 4

###### DavidL
# let's have the option to set paper size and orientation
.mb.layout.m add separator
.mb.layout.m add command -label "Page..." -underline 0 -command page
#######

menu .mb.help.m
.mb.help.m add command -label About -underline 0 \
	-command {tk_dialog .dlg ""\
"About slidedraw.\n
 This program is \n(C) Copyrighted 1998 \nby Rildo Pragana,\
 but is freely available in GPL terms.\n\
 Suggestion of improvements, inquiries and comments sent to \
 <rpragana@acm.org> are appreciated." "" -1 OK}
#.mb.help.m add command -label Contents -underline 0 -state disabled
#.mb.help.m add command -label "Canvas editing" -state disabled
#.mb.help.m add command -label "Objects" -state disabled
#.mb.help.m add command -label "File operations" -state disabled
#.mb.help.m add command -label "Customizing fonts and colors" -state disabled
#.mb.help.m add command -label "Special effects" -state disabled

#### button bar for fast selections
image create photo iline -file $sld(idir)/line.gif
image create photo iframe -file $sld(idir)/frame.gif
image create photo ibox -file $sld(idir)/box.gif
image create photo itext -file $sld(idir)/text.gif
image create photo iboxed -file $sld(idir)/boxedtext.gif
image create photo icut -file $sld(idir)/cut.gif
image create photo icopy -file $sld(idir)/copy.gif
image create photo ipaste -file $sld(idir)/paste.gif
image create photo ifront -file $sld(idir)/front.gif
image create photo iback -file $sld(idir)/back.gif
image create photo ioval -file $sld(idir)/oval.gif
image create photo iovalfilled -file $sld(idir)/filledoval.gif
image create photo iimage -file $sld(idir)/image.gif

image create bitmap flaggrp -background yellow -foreground black \
	-file $sld(idir)/flaggrp.xbm -maskfile $sld(idir)/flaggrp-mask.xbm

image create photo ibackground -width [winfo pixels .c.c $sld(dwidth)] \
     -height [winfo pixels .c.c $sld(dheight)]

button .bar.line -image iline \
	-command {.mb.objects.m invoke 1} 
button .bar.frame -image iframe \
	-command {.mb.objects.m invoke 2}
button .bar.box -image ibox \
	-command {.mb.objects.m invoke 3}
button .bar.oval -image ioval \
	-command {.mb.objects.m invoke 4}
button .bar.ovalf -image iovalfilled \
	-command {.mb.objects.m invoke 5}
button .bar.text -image itext \
	-command {.mb.objects.m invoke 6}
button .bar.boxed -image iboxed \
	-command {.mb.objects.m invoke 7}
button .bar.image -image iimage \
	-command {.mb.objects.m invoke 8}
frame .bar.sep	-width 10
frame .bar.sep2	-width 10
button .bar.cut -image icut -command cutObject
button .bar.copy -image icopy -command copyObject
button .bar.paste -image ipaste -command pasteObject
button .bar.front -image ifront -command frontObject
button .bar.back -image iback -command backObject

######
# OK, let's have the page we are working in just showed off to us. Default
# color is white, like paper.

# set sld(fillcolor) white
# insertLine 10 10
# insertBoxEnd 294m 210m

#######


pack .bar.line .bar.frame .bar.box .bar.oval .bar.ovalf .bar.text \
	.bar.boxed .bar.image .bar.sep .bar.cut .bar.copy .bar.paste .bar.sep2 \
	.bar.front .bar.back -side left
pack .mb.file .mb.edit .mb.objects .mb.layout -side left
pack .mb.help -side right

pack .c.cscrollh -side bottom -fill x
pack .c.c .c.cscrollv -side left -fill both

pack .mb .bar .c -side top -expand 1 -fill x 
pack .cnt -side left 
pack .st -side left -expand 1 -fill x

## move position so to show rulers at the beginning
.c.c xview scroll 100 units
.c.c yview scroll 100 units

dashPatchCheck
}
